// PartNumID.cpp: implementation of the CPartNum class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ChipDefs.h"
#include "PartNumID.h"
#include "resource.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

struct CPartNumID g_PartNumIDs[] = {
    /* NUC1xx's Part Number */
    {"NUC100LE3AN", 0x00010000, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC100LD3AN", 0x00010003, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC100RE3AN", 0x00010009, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC100RD3AN", 0x00010012, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC100VE3AN", 0x00100018, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC100VD3AN", 0x00010021, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC100VD2AN", 0x00010022, IDD_DIALOG_CONFIGURATION_NUC100},

    {"NUC120LE3AN", 0x00120000, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC120LD3AN", 0x00012003, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC120RE3AN", 0x00012009, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC120RD3AN", 0x00012012, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC120VE3AN", 0x00012018, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC120VD3AN", 0x00012021, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC120VD2AN", 0x00012022, IDD_DIALOG_CONFIGURATION_NUC100},

    {"NUC121WC2AE", 0x00012180, 0x00012100},
    {"NUC121Y25CN", 0x00012160, 0x00012100},
    {"NUC121ZC2AE", 0x00012145, 0x00012100},
    {"NUC121LC2AE", 0x00012125, 0x00012100},
    {"NUC121SC2AE", 0x00012105, 0x00012100},
    {"NUC125ZC2AE", 0x00012545, 0x00012100},
    {"NUC125LC2AE", 0x00012525, 0x00012100},
    {"NUC125SC2AE", 0x00012505, 0x00012100},

    {"NUC122LD2AN", 0x00012204, IDD_DIALOG_CONFIGURATION_NUC102},
    {"NUC122LC1AN", 0x00012208, IDD_DIALOG_CONFIGURATION_NUC102},
    {"NUC122SD2AN", 0x00012222, IDD_DIALOG_CONFIGURATION_NUC102},
    {"NUC122SC1AN", 0x00012226, IDD_DIALOG_CONFIGURATION_NUC102},
    {"NUC122ZD2AN", 0x00012231, IDD_DIALOG_CONFIGURATION_NUC102},
    {"NUC122ZC1AN", 0x00012235, IDD_DIALOG_CONFIGURATION_NUC102},

    {"NUC122ZD2DN", 0x30012231, IDD_DIALOG_CONFIGURATION_NUC102},
    {"NUC122LD2DN", 0x30012204, IDD_DIALOG_CONFIGURATION_NUC102},
    {"NUC122SD2DN", 0x30012222, IDD_DIALOG_CONFIGURATION_NUC102},
    {"NUC122ZC1DN", 0x30012235, IDD_DIALOG_CONFIGURATION_NUC102},
    {"NUC122LC1DN", 0x30012208, IDD_DIALOG_CONFIGURATION_NUC102},
    {"NUC122SC1DN", 0x30012226, IDD_DIALOG_CONFIGURATION_NUC102},

    /* NUC123 series */
    {"NUC123SC2AN1", 0x00012305, IDD_DIALOG_CONFIGURATION_NUC103},
    {"NUC123SD4AN0", 0x00012315, IDD_DIALOG_CONFIGURATION_NUC103},
    {"NUC123LC2AN1", 0x00012325, IDD_DIALOG_CONFIGURATION_NUC103},
    {"NUC123LD4AN0", 0x00012335, IDD_DIALOG_CONFIGURATION_NUC103},
    {"NUC123ZC2AN1", 0x00012345, IDD_DIALOG_CONFIGURATION_NUC103},
    {"NUC123ZD4AN0", 0x00012355, IDD_DIALOG_CONFIGURATION_NUC103},

    /* NUC123 series */
    {"NUC123SC2AE1", 0x10012305, IDD_DIALOG_CONFIGURATION_NUC103BN},
    {"NUC123SD4AE0", 0x10012315, IDD_DIALOG_CONFIGURATION_NUC103BN},
    {"NUC123LC2AE1", 0x10012325, IDD_DIALOG_CONFIGURATION_NUC103BN},
    {"NUC123LD4AE0", 0x10012335, IDD_DIALOG_CONFIGURATION_NUC103BN},
    {"NUC123ZC2AE1", 0x10012345, IDD_DIALOG_CONFIGURATION_NUC103BN},
    {"NUC123ZD4AE0", 0x10012355, IDD_DIALOG_CONFIGURATION_NUC103BN},

    /* NUC1xx series low density */

    {"NUC130LE3CN", 0x20013000, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC130LD2CN", 0x20013004, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC130LC1CN", 0x20013008, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC130RE3CN", 0x20013009, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC130RD2CN", 0x20013013, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC130RC1CN", 0x20013017, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC130VE3CN", 0x20013018, IDD_DIALOG_CONFIGURATION_NUC100},

    {"NUC140LE3CN", 0x20014000, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC140LD2CN", 0x20014004, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC140LC1CN", 0x20014008, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC140RE3CN", 0x20014009, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC140RD2CN", 0x20014013, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC140RC1CN", 0x20014017, IDD_DIALOG_CONFIGURATION_NUC100},
    {"NUC140VE3CN", 0x20014018, IDD_DIALOG_CONFIGURATION_NUC100},

    {"NUC100LE3DN", 0x30010000, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100LD3DN", 0x30010003, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100LD2DN", 0x30010004, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100LD1DN", 0x30010005, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100LC1DN", 0x30010008, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100RE3DN", 0x30010009, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100RD3DN", 0x30010012, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100RD2DN", 0x30010013, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100RD1DN", 0x30010014, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100RC1DN", 0x30010017, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100VE3DN", 0x30010018, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100VD3DN", 0x30010021, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC100VD2DN", 0x30010022, IDD_DIALOG_CONFIGURATION_NUC200},

    {"NUC120LE3DN", 0x30012000, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120LD3DN", 0x30012003, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120LD2DN", 0x30012004, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120LD1DN", 0x30012005, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120LC1DN", 0x30012008, IDD_DIALOG_CONFIGURATION_NUC200},

    {"NUC120VE3DN", 0x30012018, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120VD3DN", 0x30012021, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120VD2DN", 0x30012022, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120RE3DN", 0x30012027, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120RD3DN", 0x30012030, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120RD2DN", 0x30012031, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120RD1DN", 0x30012032, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC120RC1DN", 0x30012035, IDD_DIALOG_CONFIGURATION_NUC200},

    /* NUC1xxEN */
    {"NUC100VE3DE", 0x40010018, IDD_DIALOG_CONFIGURATION_NUC200},

    {"NUC120LD2DE", 0x40012004, IDD_DIALOG_CONFIGURATION_NUC200},

    /* NUC1311AE */
    {"NUC1311LD2AE", 0x11413100, IDD_DIALOG_CONFIGURATION_NUC131},
    {"NUC1311LC2AE", 0x11413101, IDD_DIALOG_CONFIGURATION_NUC131},
    {"M0515LDE", 0x11413103, IDD_DIALOG_CONFIGURATION_NUC131},

    /* NUC131AE */
    {"NUC131LD2AEU", 0xF0013100, IDD_DIALOG_CONFIGURATION_NUC131},
    {"NUC131LC2AEU", 0xF0013103, IDD_DIALOG_CONFIGURATION_NUC131},
    {"NUC131SD2AEU", 0xF0013110, IDD_DIALOG_CONFIGURATION_NUC131},
    {"NUC131SC2AEU", 0xF0013113, IDD_DIALOG_CONFIGURATION_NUC131},
    {"NUC131LD2AE", 0x10013100, IDD_DIALOG_CONFIGURATION_NUC131},
    {"NUC131LC2AE", 0x10013103, IDD_DIALOG_CONFIGURATION_NUC131},
    {"NUC131SD2AE", 0x10013110, IDD_DIALOG_CONFIGURATION_NUC131},
    {"NUC131SC2AE", 0x10013113, IDD_DIALOG_CONFIGURATION_NUC131},

    {"M0A86SD2AE", 0x100A8610, IDD_DIALOG_CONFIGURATION_NUC131},

    /* M0518AE */
    {"M0518LD2AE", 0x10051800, IDD_DIALOG_CONFIGURATION_NUC131},
    {"M0518LC2AE", 0x10051803, IDD_DIALOG_CONFIGURATION_NUC131},
    {"M0518SD2AE", 0x10051810, IDD_DIALOG_CONFIGURATION_NUC131},
    {"M0518SC2AE", 0x10051813, IDD_DIALOG_CONFIGURATION_NUC131},

    {"NM1320LC2AE", 0x00032003, IDD_DIALOG_CONFIGURATION_NUC131},

    /* NUC2xxAE */

    {"NUC220LE3AE", 0x40022000, IDD_DIALOG_CONFIGURATION_NUC200},

    {"NUC230LC2AE", 0x10023007, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC230LD2AE", 0x10023004, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC230LE3AE", 0x10023000, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC230SC2AE", 0x10023034, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC230SD2AE", 0x10023031, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC230SE3AE", 0x10023027, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC230VE3AE", 0x10023018, IDD_DIALOG_CONFIGURATION_NUC200},

    {"NUC240LC2AE", 0x10024007, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC240LD2AE", 0x10024004, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC240LE3AE", 0x10024000, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC240SC2AE", 0x10024034, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC240SD2AE", 0x10024031, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC240SE3AE", 0x10024027, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC240VE3AE", 0x10024018, IDD_DIALOG_CONFIGURATION_NUC200},

    /* NUC2201 */
    {"NUC2201LE3AE", 0x20024000, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC2201SE3AE", 0x20024027, IDD_DIALOG_CONFIGURATION_NUC200},

    /* NUC200xxxAN */
    {"NUC200LE3AN", 0x00020000, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC200LD2AN", 0x00020004, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC200LC2AN", 0x00020007, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC200VE3AN", 0x00020018, IDD_DIALOG_CONFIGURATION_NUC200},

    {"NUC200SE3AN", 0x00020027, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC200SD2AN", 0x00020031, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC200SC2AN", 0x00020034, IDD_DIALOG_CONFIGURATION_NUC200},

    {"NUC220LE3AN", 0x00022000, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC220LD2AN", 0x00022004, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC220LC2AN", 0x00022007, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC220VE3AN", 0x00022018, IDD_DIALOG_CONFIGURATION_NUC200},

    {"NUC220SE3AN", 0x00022027, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC220SD2AN", 0x00022031, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC220SC2AN", 0x00022034, IDD_DIALOG_CONFIGURATION_NUC200},

    /* NUC029 */
    {"NUC029NAN", 0x00295A06, IDD_DIALOG_CONFIGURATION_M051CN},
    {"NUC029LAN", 0x00295A00, IDD_DIALOG_CONFIGURATION_M051CN},
    {"NUC029TAN", 0x00295804, IDD_DIALOG_CONFIGURATION_M051CN},
    {"NUC029CIG1", 0x00295824, IDD_DIALOG_CONFIGURATION_M051CN},
    {"NUC029ZAN", 0x00295A03, IDD_DIALOG_CONFIGURATION_M051CN},
    {"NUC029TAE", 0x30295804, IDD_DIALOG_CONFIGURATION_M051CN},
    {"NUC029FAE", 0x00295415, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"NUC029LDE", 0x00295A30, IDD_DIALOG_CONFIGURATION_NUC131},
    {"NUC029SDE", 0x00295A31, IDD_DIALOG_CONFIGURATION_NUC131},
    {"NUC029LEE", 0x00295B40, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC029SEE", 0x00295B41, IDD_DIALOG_CONFIGURATION_NUC200},
    {"NUC029LGE", 0x00295C50, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC029SGE", 0x00295C51, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC029KGE", 0x00295C52, IDD_DIALOG_CONFIGURATION_M0564},

    /* M031 */
    {"M031LE3AE", 0x01131E00, NUC_CHIP_TYPE_M031},
    {"M031SE3AE", 0x01131E10, NUC_CHIP_TYPE_M031},
    {"M031BTYE3AN", 0x01131E90, NUC_CHIP_TYPE_M031},
    {"M031TE3AE", 0x01131EE0, NUC_CHIP_TYPE_M031},
    {"M032LE3AE", 0x01132E00, NUC_CHIP_TYPE_M031},
    {"M032SE3AE", 0x01132E10, NUC_CHIP_TYPE_M031},
    {"M031TD2AE", 0x01131DE0, NUC_CHIP_TYPE_M031},
    {"M031LD2AE", 0x01131D00, NUC_CHIP_TYPE_M031},
    {"M031SD2AE", 0x01131D10, NUC_CHIP_TYPE_M031},
    {"M031LC2AE", 0x01131D01, NUC_CHIP_TYPE_M031},
    {"M031SC2AE", 0x01131D11, NUC_CHIP_TYPE_M031},
    {"M031BTYD2AN", 0x01131D90, NUC_CHIP_TYPE_M031},
    {"M031FC1AE", 0x01131CB0, NUC_CHIP_TYPE_M031},
    {"M031EC1AE", 0x01131CA0, NUC_CHIP_TYPE_M031},
    {"M031TC1AE", 0x01131CE0, NUC_CHIP_TYPE_M031},
    {"M031FB0AE", 0x01131BB0, NUC_CHIP_TYPE_M031},
    {"M031EB0AE", 0x01131BA0, NUC_CHIP_TYPE_M031},
    {"M031TB0AE", 0x01131BE0, NUC_CHIP_TYPE_M031},
    {"M031SIAAE", 0x01131110, NUC_CHIP_TYPE_M031G},
    {"M032SIAAE", 0x01132110, NUC_CHIP_TYPE_M031G},
    {"M031KIAAE", 0x01131140, NUC_CHIP_TYPE_M031G},
    {"M032KIAAE", 0x01132140, NUC_CHIP_TYPE_M031G},
    {"M031LG8AE", 0x01131600, NUC_CHIP_TYPE_M031G},
    {"M032LG8AE", 0x01132600, NUC_CHIP_TYPE_M031G},
    {"M031SG8AE", 0x01131610, NUC_CHIP_TYPE_M031G},
    {"M032SG8AE", 0x01132610, NUC_CHIP_TYPE_M031G},
    {"M031KG8AE", 0x01131640, NUC_CHIP_TYPE_M031G},
    {"M032KG8AE", 0x01132640, NUC_CHIP_TYPE_M031G},
    {"M031LG6AE", 0x01131601, NUC_CHIP_TYPE_M031G},
    {"M032LG6AE", 0x01132601, NUC_CHIP_TYPE_M031G},
    {"M031SG6AE", 0x01131611, NUC_CHIP_TYPE_M031G},
    {"M032SG6AE", 0x01132611, NUC_CHIP_TYPE_M031G},
    {"M031KG6AE", 0x01131641, NUC_CHIP_TYPE_M031G},
    {"M032KG6AE", 0x01132641, NUC_CHIP_TYPE_M031G},
    {"M032TD2AE", 0x01132DE0, NUC_CHIP_TYPE_M031},
    {"M032LD2AE", 0x01132D00, NUC_CHIP_TYPE_M031},
    {"M032LC2AE", 0x01132D01, NUC_CHIP_TYPE_M031},
    {"M030TD2AE", 0x01130DE0, NUC_CHIP_TYPE_M031},
    {"M030LD2AE", 0x01130D00, NUC_CHIP_TYPE_M031},
    {"M030FD2AE", 0x01130DB0, NUC_CHIP_TYPE_M031},
    {"M032FC1AE", 0x01132CB0, NUC_CHIP_TYPE_M031},
    {"M032EC1AE", 0x01132CA0, NUC_CHIP_TYPE_M031},
    {"M032TC1AE", 0x01132CE0, NUC_CHIP_TYPE_M031},

    /* M05x's Part Number */
    {"M052LAN", 0x00005200, IDD_DIALOG_CONFIGURATION_M051},
    {"M052ZAN", 0x00005203, IDD_DIALOG_CONFIGURATION_M051},
    {"M054LAN", 0x00005400, IDD_DIALOG_CONFIGURATION_M051},
    {"M054ZAN", 0x00005403, IDD_DIALOG_CONFIGURATION_M051},
    {"M058LAN", 0x00005800, IDD_DIALOG_CONFIGURATION_M051},
    {"M058ZAN", 0x00005803, IDD_DIALOG_CONFIGURATION_M051},
    {"M0516LAN", 0x00005A00, IDD_DIALOG_CONFIGURATION_M051},
    {"M0516ZAN", 0x00005A03, IDD_DIALOG_CONFIGURATION_M051},

    {"M058SLAN", 0x00005810, IDD_DIALOG_CONFIGURATION_M058},
    {"M058SZAN", 0x00005813, IDD_DIALOG_CONFIGURATION_M058},
    {"M058SSAN", 0x00005816, IDD_DIALOG_CONFIGURATION_M058},
    {"M058SFAN", 0x00005818, IDD_DIALOG_CONFIGURATION_M058},

    {"M052LBN", 0x10005200, IDD_DIALOG_CONFIGURATION_M051BN},
    {"M052ZBN", 0x10005203, IDD_DIALOG_CONFIGURATION_M051BN},
    {"M054LBN", 0x10005400, IDD_DIALOG_CONFIGURATION_M051BN},
    {"M054ZBN", 0x10005403, IDD_DIALOG_CONFIGURATION_M051BN},
    {"M058LBN", 0x10005800, IDD_DIALOG_CONFIGURATION_M051BN},
    {"M058ZBN", 0x10005803, IDD_DIALOG_CONFIGURATION_M051BN},
    {"M0516LBN", 0x10005A00, IDD_DIALOG_CONFIGURATION_M051BN},
    {"M0516ZBN", 0x10005A03, IDD_DIALOG_CONFIGURATION_M051BN},

    /* M051DN*/
    {"M052LDN", 0x20005200, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M052ZDN", 0x20005203, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M054LDN", 0x20005400, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M054ZDN", 0x20005403, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M058LDN", 0x20005800, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M058ZDN", 0x20005803, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M0516LDN", 0x20005A00, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M0516ZDN", 0x20005A03, IDD_DIALOG_CONFIGURATION_M051CN},

    /* M051DE*/
    {"M052LDE", 0x30005200, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M052ZDE", 0x30005203, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M054LDE", 0x30005400, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M054ZDE", 0x30005403, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M058LDE", 0x30005800, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M058ZDE", 0x30005803, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M058MDE", 0x30005807, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M0516LDE", 0x30005A00, IDD_DIALOG_CONFIGURATION_M051CN},
    {"M0516ZDE", 0x30005A03, IDD_DIALOG_CONFIGURATION_M051CN},

    {"NM1330LC1AE", 0x30005810, IDD_DIALOG_CONFIGURATION_M051CN},
    {"NM1330LD2AE", 0x30005A10, IDD_DIALOG_CONFIGURATION_M051CN},

    //Nano112
    {"Nano112LB1AN", 0x00111202, IDD_DIALOG_CONFIGURATION_NANO112},
    {"Nano112LC2AN", 0x00111204, IDD_DIALOG_CONFIGURATION_NANO112},
    {"Nano112SB1AN", 0x00111206, IDD_DIALOG_CONFIGURATION_NANO112},
    {"Nano112SC2AN", 0x00111208, IDD_DIALOG_CONFIGURATION_NANO112},
    {"Nano112RB1AN", 0x00111210, IDD_DIALOG_CONFIGURATION_NANO112},
    {"Nano112RC2AN", 0x00111212, IDD_DIALOG_CONFIGURATION_NANO112},
    {"Nano112VC2AN", 0x00111216, IDD_DIALOG_CONFIGURATION_NANO112},

    {"Nano102ZB1AN", 0x00110202, IDD_DIALOG_CONFIGURATION_NANO112},
    {"Nano102ZC2AN", 0x00110204, IDD_DIALOG_CONFIGURATION_NANO112},
    {"Nano102LB1AN", 0x00110206, IDD_DIALOG_CONFIGURATION_NANO112},
    {"Nano102LC2AN", 0x00110208, IDD_DIALOG_CONFIGURATION_NANO112},
    {"Nano102SC2AN", 0x00110212, IDD_DIALOG_CONFIGURATION_NANO112},

    //Nano103
    {"Nano103SD3AE", 0x00110301, IDD_DIALOG_CONFIGURATION_NANO103},
    {"Nano103LD3AE", 0x00110304, IDD_DIALOG_CONFIGURATION_NANO103},
    {"Nano103ZD3AE", 0x00110307, IDD_DIALOG_CONFIGURATION_NANO103},

    {"Nano100VD3AN", 0x00110012, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano100VD2AN", 0x00110013, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano100SD3AN", 0x00110015, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano100SD2AN", 0x00110016, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano100LD3AN", 0x00110018, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano100LD2AN", 0x00110019, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano100SC2AN", 0x00110023, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano100LC2AN", 0x00110025, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano100ZD3AN", 0x00110027, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano100ZD2AN", 0x00110028, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano100ZC2AN", 0x00110029, IDD_DIALOG_CONFIGURATION_NANO100},

    {"Nano120VD3AN", 0x00112012, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano120VD2AN", 0x00112013, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano120SD3AN", 0x00112015, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano120SD2AN", 0x00112016, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano120LD3AN", 0x00112018, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano120LD2AN", 0x00112019, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano120SC2AN", 0x00112023, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano120LC2AN", 0x00112025, IDD_DIALOG_CONFIGURATION_NANO100},

    {"Nano120ZD3AN", 0x00112027, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano120ZD2AN", 0x00112028, IDD_DIALOG_CONFIGURATION_NANO100},
    {"Nano120ZC2AN", 0x00112029, IDD_DIALOG_CONFIGURATION_NANO100},

    {"Nano130VD3AN", 0x00113012, IDD_DIALOG_CONFIGURATION_NANO100},

    //Nano100
    {"Nano100KE3BN", 0x00110030, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100SE3BN", 0x00110034, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100LE3BN", 0x00110036, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100KD3BN", 0x00110038, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100SD3BN", 0x0011003C, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100SD2BN", 0x0011003D, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100LD3BN", 0x0011003E, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100LD2BN", 0x0011003F, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100SC2BN", 0x00110042, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100LC2BN", 0x00110043, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100NE3BN", 0x00110044, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100ND3BN", 0x00110045, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100ND2BN", 0x00110046, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano100WE3BN", 0x00110047, IDD_DIALOG_CONFIGURATION_NANO100BN},

    {"Nano110KE3BN", 0x00111030, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano110SE3BN", 0x00111034, IDD_DIALOG_CONFIGURATION_NANO100BN},

    {"Nano110KD3BN", 0x00111038, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano110KD2BN", 0x00111039, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano110SD3BN", 0x0011103C, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano110SD2BN", 0x0011103D, IDD_DIALOG_CONFIGURATION_NANO100BN},

    {"Nano110KC2BN", 0x00111040, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano110SC2BN", 0x00111042, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano110RC2BN", 0x00111043, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano110RD2BN", 0x00111044, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano110RD3BN", 0x00111045, IDD_DIALOG_CONFIGURATION_NANO100BN},

    {"Nano120KE3BN", 0x00112030, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano120SE3BN", 0x00112034, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano120LE3BN", 0x00112036, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano120KD3BN", 0x00112038, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano120SD3BN", 0x0011203C, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano120SD2BN", 0x0011203D, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano120LD3BN", 0x0011203E, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano120LD2BN", 0x0011203F, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano120SC2BN", 0x00112042, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano120LC2BN", 0x00112043, IDD_DIALOG_CONFIGURATION_NANO100BN},

    {"Nano130KE3BN", 0x00113030, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano130SE3BN", 0x00113034, IDD_DIALOG_CONFIGURATION_NANO100BN},

    {"Nano130KD3BN", 0x00113038, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano130KD2BN", 0x00113039, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano130SD3BN", 0x0011303C, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano130SD2BN", 0x0011303D, IDD_DIALOG_CONFIGURATION_NANO100BN},

    {"Nano130KC2BN", 0x00113040, IDD_DIALOG_CONFIGURATION_NANO100BN},
    {"Nano130SC2BN", 0x00113042, IDD_DIALOG_CONFIGURATION_NANO100BN},

    //Mini51
    {"MINI51LAN", 0x00205100, IDD_DIALOG_CONFIGURATION_MINI51},
    {"MINI51ZAN", 0x00205103, IDD_DIALOG_CONFIGURATION_MINI51},
    {"MINI51TAN", 0x00205104, IDD_DIALOG_CONFIGURATION_MINI51},
    {"MINI52LAN", 0x00205200, IDD_DIALOG_CONFIGURATION_MINI51},
    {"MINI52ZAN", 0x00205203, IDD_DIALOG_CONFIGURATION_MINI51},
    {"MINI52TAN", 0x00205204, IDD_DIALOG_CONFIGURATION_MINI51},
    {"MINI54LAN", 0x00205400, IDD_DIALOG_CONFIGURATION_MINI51},
    {"MINI54ZAN", 0x00205403, IDD_DIALOG_CONFIGURATION_MINI51},
    {"MINI54TAN", 0x00205404, IDD_DIALOG_CONFIGURATION_MINI51},

    /* MINI51DE */
    {"MINI51LDE", 0x20205100, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI51QDE", 0x20205101, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI51ZDE", 0x20205103, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI51TDE", 0x20205104, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI51FDE", 0x20205105, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI52LDE", 0x20205200, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI52QDE", 0x20205201, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI52ZDE", 0x20205203, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI52TDE", 0x20205204, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI52FDE", 0x20205205, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI54LDE", 0x20205400, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI54QDE", 0x20205401, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI54ZDE", 0x20205403, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI54TDE", 0x20205404, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI54FDE", 0x20205405, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI54FHC", 0x20205406, IDD_DIALOG_CONFIGURATION_MINI51CN},

    /* MINI51X NM1200 */
    {"MINI55LDE", 0x00505500, IDD_DIALOG_CONFIGURATION_NM1200},
    {"MINI55ZDE", 0x00505503, IDD_DIALOG_CONFIGURATION_NM1200},
    {"MINI55TDE", 0x00505504, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM1200LBAE", 0x00605400, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM1200ZBAE", 0x00605403, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM1200TBAE", 0x00605404, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM1100XBAE", 0x00605407, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM1100FBAE", 0x00605408, IDD_DIALOG_CONFIGURATION_NM1200},

    /* NM1820 */
    {"NM18200S", 0x00682010, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM18201S", 0x00682011, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM18202S", 0x00682012, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM1820ZB0AE", 0x00682020, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM18200D", 0x00682030, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM18200Y", 0x00682040, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM18201Y", 0x00682041, IDD_DIALOG_CONFIGURATION_NM1200},
    {"NM18202Y", 0x00682042, IDD_DIALOG_CONFIGURATION_NM1200},

    /* Mini58 */
    {"MINI58LDE", 0x00A05800, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI58QDE", 0x00A05801, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI58ZDE", 0x00A05803, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI58TDE", 0x00A05804, IDD_DIALOG_CONFIGURATION_MINI51CN},
    {"MINI58FDE", 0x00A05805, IDD_DIALOG_CONFIGURATION_MINI51CN},

    /* Mini57 */
    {"MINI57FDE", 0x00B05720, IDD_DIALOG_CONFIGURATION_NM1120},
    {"MINI57EDE", 0x00B05740, IDD_DIALOG_CONFIGURATION_NM1120},
    {"MINI57XDE", 0x00B05750, IDD_DIALOG_CONFIGURATION_NM1120},
    {"MINI57TDE", 0x00B05760, IDD_DIALOG_CONFIGURATION_NM1120},

    /* NM1120 */
    {"NM1120FC1AE", 0x00B01420, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1120EC1AE", 0x00B01440, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1120XC1AE", 0x00B01450, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1120ZC1AE", 0x00B01470, IDD_DIALOG_CONFIGURATION_NM1120},

    /* NM1810 */
    {"NM18100Y", 0x00B81040, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM18101Y", 0x00B81041, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM18105Y", 0x00B81045, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM18107Y", 0x00B81047, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1817NT", 0x00B81720, IDD_DIALOG_CONFIGURATION_NM1120},

    /* TF5103 */
    {"TF5103D", 0x0C051000, IDD_DIALOG_CONFIGURATION_NM1120},
    {"TF5103Y", 0x0C051090, IDD_DIALOG_CONFIGURATION_NM1120},
    {"TF5102Y", 0x0C051091, IDD_DIALOG_CONFIGURATION_NM1120},

    /* NM1230 */
    {"NM1234D", 0x0C012300, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1232D", 0x0C012302, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1220EBK0", 0x0C01230A, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1234Y", 0x0C012390, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1232Y", 0x0C012392, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1233D", 0x0C012301, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1233Y", 0x0C012391, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM18307Y", 0x0C082390, IDD_DIALOG_CONFIGURATION_NM1120},

    /* NM1240 */
    {"NM1243D48", 0x0C112401, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1243Y48", 0x0C112491, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1243Y", 0x0C1124E1, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1244D48", 0x0C112400, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1244Y48", 0x0C112490, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM1244Y", 0x0C1124E0, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM18407Y", 0x0C182490, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM18440D", 0x0C182400, IDD_DIALOG_CONFIGURATION_NM1120},
    {"NM18407SY", 0x0C182491, IDD_DIALOG_CONFIGURATION_NM1120},
	{"NM18402Y", 0x0C182492, IDD_DIALOG_CONFIGURATION_NM1120},

    /* N32F030 */
    {"N32F030D", 0x0C112430, IDD_DIALOG_CONFIGURATION_NM1120},
    {"N32F030Y", 0x0C112431, IDD_DIALOG_CONFIGURATION_NM1120},
    {"N32F030X", 0x0C112432, IDD_DIALOG_CONFIGURATION_NM1120},

    /* NM1500 */
    {"NM1510LC1AE", 0x00351006, IDD_DIALOG_CONFIGURATION_MT500},
    {"NM1520LC2AE", 0x00352005, IDD_DIALOG_CONFIGURATION_MT500},
    {"NM1520LD2AE", 0x00352003, IDD_DIALOG_CONFIGURATION_MT500},
    {"NM1520RC2AE", 0x00352025, IDD_DIALOG_CONFIGURATION_MT500},
    {"NM1520RD2AE", 0x00352023, IDD_DIALOG_CONFIGURATION_MT500},
    {"NM1530LE3AE", 0x00353000, IDD_DIALOG_CONFIGURATION_MT500},
    {"NM1530VD3AE", 0x00353032, IDD_DIALOG_CONFIGURATION_MT500},
    {"NM1530VE3AE", 0x00353030, IDD_DIALOG_CONFIGURATION_MT500},

    //M0519 series
    {"M0519VE3AE", 0x00051930, IDD_DIALOG_CONFIGURATION_MT500},
    {"M0519SE3AE", 0x00051920, IDD_DIALOG_CONFIGURATION_MT500},
    {"M0519SD3AE", 0x00051922, IDD_DIALOG_CONFIGURATION_MT500},
    {"M0519LE3AE", 0x00051900, IDD_DIALOG_CONFIGURATION_MT500},
    {"M0519LD3AE", 0x00051902, IDD_DIALOG_CONFIGURATION_MT500},

    //M0564 series
    {"M0564LE4AE", 0x00C56405, IDD_DIALOG_CONFIGURATION_M0564},
    {"M0564LG4AE", 0x00C56404, IDD_DIALOG_CONFIGURATION_M0564},
    {"M0564SE4AE", 0x00C56413, IDD_DIALOG_CONFIGURATION_M0564},
    {"M0564SG4AE", 0x00C56412, IDD_DIALOG_CONFIGURATION_M0564},
    {"M0564VG4AE", 0x00C56431, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC126NE4AE", 0x00C05206, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC126LE4AE", 0x00C05205, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC126LG4AE", 0x00C05204, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC126SE4AE", 0x00C05213, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC126SG4AE", 0x00C05212, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC126VG4AE", 0x00C05231, IDD_DIALOG_CONFIGURATION_M0564},

    //NUC1261
    {"NUC1261SG4AE", 0x01205212, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC1261SE4AE", 0x01205213, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC1261LG4AE", 0x01205204, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC1261LE4AE", 0x01205205, IDD_DIALOG_CONFIGURATION_M0564},
    {"NUC1261NE4AE", 0x01205206, IDD_DIALOG_CONFIGURATION_M0564},

    //NUC1262
    {"NUC1262SE4AE", 0x01812610, IDD_DIALOG_CONFIGURATION_NUC1262},
    {"NUC1262LE4AE", 0x01812600, IDD_DIALOG_CONFIGURATION_NUC1262},
    {"NUC1262NE4AE", 0x01812690, IDD_DIALOG_CONFIGURATION_NUC1262},
    {"NUC1262YE4AE", 0x01812691, IDD_DIALOG_CONFIGURATION_NUC1262},

    //NUC1263
    {"NUC1263SD4AE", 0x01D12610, IDD_DIALOG_CONFIGURATION_NUC1262},
    {"NUC1263LD4AE", 0x01D12600, IDD_DIALOG_CONFIGURATION_NUC1262},
    {"NUC1263ND4AE", 0x01D12690, IDD_DIALOG_CONFIGURATION_NUC1262},
    {"NUC1263ZD4AE", 0x01D126E0, IDD_DIALOG_CONFIGURATION_NUC1262},
    {"NUC1263SD4CE", 0x21D12610, IDD_DIALOG_CONFIGURATION_NUC1262},
    {"NUC1263LD4CE", 0x21D12600, IDD_DIALOG_CONFIGURATION_NUC1262},
    {"NUC1263ND4CE", 0x21D12690, IDD_DIALOG_CONFIGURATION_NUC1262},
    {"NUC1263ZD4CE", 0x21D126E0, IDD_DIALOG_CONFIGURATION_NUC1262},

    /* NUC4xx series*/
    {"NUC472HI8AE", 0x00047201, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC472HG8AE", 0x00047203, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC472JI8AE", 0x00047204, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC472JG8AE", 0x00047206, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC472KI8AE", 0x00047207, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC472KG8AE", 0x00047209, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC472VI8AE", 0x00047210, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC472VG8AE", 0x00047212, IDD_DIALOG_CONFIGURATION_NUC400},

    {"NUC442JI8AE", 0x00044201, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC442JG8AE", 0x00044203, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC442KI8AE", 0x00044204, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC442KG8AE", 0x00044206, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC442VI8AE", 0x00044207, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC442VG8AE", 0x00044209, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC442RI8AE", 0x00044210, IDD_DIALOG_CONFIGURATION_NUC400},
    {"NUC442RG8AE", 0x00044212, IDD_DIALOG_CONFIGURATION_NUC400},

    /* M55M1 */
    {"M55M1ES", 0x00551000, NUC_CHIP_TYPE_M55M1}, //not release, TC8263

    /* M451 series */
    {"M451VG6AE", 0x00845130, NUC_CHIP_TYPE_M451},
    {"M451VE6AE", 0x00845131, NUC_CHIP_TYPE_M451},
    {"M451RG6AE", 0x00845120, NUC_CHIP_TYPE_M451},
    {"M451RE6AE", 0x00845121, NUC_CHIP_TYPE_M451},
    {"M451LG6AE", 0x00845100, NUC_CHIP_TYPE_M451},
    {"M451LE6AE", 0x00845101, NUC_CHIP_TYPE_M451},

    {"M452VG6AE", 0x00845230, NUC_CHIP_TYPE_M451},
    {"M452VE6AE", 0x00845231, NUC_CHIP_TYPE_M451},
    {"M452RG6AE", 0x00845220, NUC_CHIP_TYPE_M451},
    {"M452RE6AE", 0x00845221, NUC_CHIP_TYPE_M451},
    {"M452LG6AE", 0x00845200, NUC_CHIP_TYPE_M451},
    {"M452LE6AE", 0x00845201, NUC_CHIP_TYPE_M451},
    {"M4LEDRG6AE", 0x00845720, NUC_CHIP_TYPE_M451},
    {"M4LEDRE6AE", 0x00845721, NUC_CHIP_TYPE_M451},
    {"M4LEDLG6AE", 0x00845700, NUC_CHIP_TYPE_M451},
    {"M4LEDLE6AE", 0x00845701, NUC_CHIP_TYPE_M451},

    {"M453VG6AE", 0x00845330, NUC_CHIP_TYPE_M451},
    {"M453VE6AE", 0x00845331, NUC_CHIP_TYPE_M451},
    {"M453RG6AE", 0x00845320, NUC_CHIP_TYPE_M451},
    {"M453RE6AE", 0x00845321, NUC_CHIP_TYPE_M451},
    {"M453LG6AE", 0x00845300, NUC_CHIP_TYPE_M451},
    {"M453LE6AE", 0x00845301, NUC_CHIP_TYPE_M451},

    {"M4TKVG6AE", 0x00845430, NUC_CHIP_TYPE_M451},
    {"M4TKVE6AE", 0x00845431, NUC_CHIP_TYPE_M451},
    {"M4TKRG6AE", 0x00845420, NUC_CHIP_TYPE_M451},
    {"M4TKRE6AE", 0x00845421, NUC_CHIP_TYPE_M451},
    {"M4TKLG6AE", 0x00845400, NUC_CHIP_TYPE_M451},
    {"M4TKLE6AE", 0x00845401, NUC_CHIP_TYPE_M451},

    {"M451MLG6AE", 0x00845000, NUC_CHIP_TYPE_M451},
    {"M451MLE6AE", 0x00845001, NUC_CHIP_TYPE_M451},

    {"M451RD3AE", 0x00945120, NUC_CHIP_TYPE_M451},
    {"M451RC3AE", 0x00945121, NUC_CHIP_TYPE_M451},
    {"M451LD3AE", 0x00945100, NUC_CHIP_TYPE_M451},
    {"M451LC3AE", 0x00945101, NUC_CHIP_TYPE_M451},

    {"M452RD3AE", 0x00945220, NUC_CHIP_TYPE_M451},
    {"M452LD3AE", 0x00945200, NUC_CHIP_TYPE_M451},
    {"M452LC3AE", 0x00945201, NUC_CHIP_TYPE_M451},

    {"M453VD3AE", 0x00945330, NUC_CHIP_TYPE_M451},
    {"M453RD3AE", 0x00945320, NUC_CHIP_TYPE_M451},
    {"M453LD3AE", 0x00945300, NUC_CHIP_TYPE_M451},
    {"M453LC3AE", 0x00945301, NUC_CHIP_TYPE_M451},

    {"M451MSD3AE", 0x00945010, NUC_CHIP_TYPE_M451},
    {"M451MSC3AE", 0x00945011, NUC_CHIP_TYPE_M451},
    {"M451MLD3AE", 0x00945000, NUC_CHIP_TYPE_M451},
    {"M451MLC3AE", 0x00945001, NUC_CHIP_TYPE_M451},

    /* M4521 series */
    {"M4521SE6AE", 0x00E45210, NUC_CHIP_TYPE_M451},
    {"M4521LE6AE", 0x00E45200, NUC_CHIP_TYPE_M451},

    /* M481 series */
    {"M481SIDAE", 0x00D48110, IDD_DIALOG_CONFIGURATION_M480},
    {"M481LIDAE", 0x00D48100, IDD_DIALOG_CONFIGURATION_M480},
    {"M481ZIDAE", 0x00D481E0, IDD_DIALOG_CONFIGURATION_M480},
    {"M482KIDAE", 0x00D48240, IDD_DIALOG_CONFIGURATION_M480},
    {"M482SIDAE", 0x00D48210, IDD_DIALOG_CONFIGURATION_M480},
    {"M482LIDAE", 0x00D48200, IDD_DIALOG_CONFIGURATION_M480},
    {"M482ZIDAE", 0x00D482E0, IDD_DIALOG_CONFIGURATION_M480},
    {"M483KIDAE", 0x00D48340, IDD_DIALOG_CONFIGURATION_M480},
    {"M483SIDAE", 0x00D48310, IDD_DIALOG_CONFIGURATION_M480},
    {"M484KIDAE", 0x00D48440, IDD_DIALOG_CONFIGURATION_M480},
	{"M484SIDAE", 0x00D48410, IDD_DIALOG_CONFIGURATION_M480},
	{"M484SIDAE2U", 0x00D48412, IDD_DIALOG_CONFIGURATION_M480},
    {"M485KIDAE", 0x00D48540, IDD_DIALOG_CONFIGURATION_M480},
    {"M485SIDAE", 0x00D48510, IDD_DIALOG_CONFIGURATION_M480},
    {"M485LIDAE", 0x00D48500, IDD_DIALOG_CONFIGURATION_M480},
    {"M485YIDAE", 0x00D48590, IDD_DIALOG_CONFIGURATION_M480},
	{"M485ZIDAE", 0x00D485E0, IDD_DIALOG_CONFIGURATION_M480},
    {"M487JIDAE", 0x00D48750, IDD_DIALOG_CONFIGURATION_M480},
    {"M487KMCAN", 0x00D4874E, IDD_DIALOG_CONFIGURATION_M480},
    {"M487KIDAE", 0x00D48740, IDD_DIALOG_CONFIGURATION_M480},
    {"M487SIDAE", 0x00D48710, IDD_DIALOG_CONFIGURATION_M480},

    /* M480LD series */
    {"M481SGCAE", 0x01348110, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M481SE8AE", 0x01348112, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M481SGCAE2A", 0x01348114, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M481LGCAE", 0x01348100, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M481LGCAEU", 0x0134810F, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M481LE8AE", 0x01348102, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M481ZGCAE", 0x013481E0, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M481ZE8AE", 0x013481E2, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M482KGCAE", 0x01348240, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M482SGCAE", 0x01348210, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M482SE8AE", 0x01348212, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M482LGCAE", 0x01348200, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M482LE8AE", 0x01348202, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M482ZGCAE", 0x013482E0, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M482ZE8AE", 0x013482E2, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M483KGCAE", 0x01348340, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M483SGCAE", 0x01348310, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M483SE8AE", 0x01348312, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M483KGCAE2A", 0x01348344, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M483SGCAE2A", 0x01348314, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M433SE8AE", 0x01343312, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M433LE8AE", 0x01343302, IDD_DIALOG_CONFIGURATION_M480LD},

    /* M479 series */
    {"M479SG8AEE", 0x01347911, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M479LG8AEE", 0x01347901, IDD_DIALOG_CONFIGURATION_M480LD},
    {"M479NG8AEE", 0x01347991, IDD_DIALOG_CONFIGURATION_M480LD},

    /* M252_C series */
    {"M252FC2AE", 0x00F252B0, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252EC2AE", 0x00F252A0, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252ZC2AE", 0x00F252E0, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251FC2AE", 0x00F251B0, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251EC2AE", 0x00F251A0, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251ZC2AE", 0x00F251E0, IDD_DIALOG_CHIP_SETTING_CFG_M251},

    /* M252_D series */
    {"M251SD2AE", 0x00F25110, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251LD2AE", 0x00F25101, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251ZD2AE", 0x00F251C2, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251SC2AE", 0x00F25113, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251LC2AE", 0x00F25104, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252SD2AE", 0x00F25210, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252LD2AE", 0x00F25201, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252ZD2AE", 0x00F252C2, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252SC2AE", 0x00F25213, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252LC2AE", 0x00F25204, IDD_DIALOG_CHIP_SETTING_CFG_M251},

    {"NDA102SD2", 0x00F25112, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"NDA102UD2", 0x00F25170, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"NDA102TD2", 0x00F251C5, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"NDA102SE3", 0x00F25116, IDD_DIALOG_CHIP_SETTING_CFG_M251},

    /* M252_E series */
    {"M252KE3AE", 0x00F25243, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252SE3AE", 0x00F25214, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252LE3AE", 0x00F25205, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251KE3AE", 0x00F25143, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251SE3AE", 0x00F25114, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251LE3AE", 0x00F25105, IDD_DIALOG_CHIP_SETTING_CFG_M251},

    /* M252_G series */
    {"M252KG6AE", 0x00F25240, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252SG6AE", 0x00F25211, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M252LG6AE", 0x00F25202, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251KG6AE", 0x00F25140, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251SG6AE", 0x00F25111, IDD_DIALOG_CHIP_SETTING_CFG_M251},
    {"M251LG6AE", 0x00F25102, IDD_DIALOG_CHIP_SETTING_CFG_M251},

    /* M254/6/8 series */
    {"M254SD3AE", 0x00F25410, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M254SE3AE", 0x00F25411, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M254KE3AE", 0x00F25441, IDD_DIALOG_CHIP_SETTING_CFG_M258},

    {"M256SE3AE", 0x00F25611, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M256KE3AE", 0x00F25641, IDD_DIALOG_CHIP_SETTING_CFG_M258},

    {"M258SE3AE", 0x00F25811, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M258KE3AE", 0x00F25841, IDD_DIALOG_CHIP_SETTING_CFG_M258},

    {"M253ZE3AE", 0x00F250E0, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M253ZE3BE", 0x00F250E1, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M253LE3AE", 0x00F25001, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M253LE3BE", 0x00F25003, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M253LD3AE", 0x00F25000, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M253LD3BE", 0x00F25002, IDD_DIALOG_CHIP_SETTING_CFG_M258},

    /* M256D series */
    {"M254SD2AE", 0x01A25411, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M256MD2AE", 0x01A256A1, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M256SD2AE", 0x01A25611, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M254MD2AE", 0x01A254A1, IDD_DIALOG_CHIP_SETTING_CFG_M258},

    /* M258G series */
    {"M258KG6AE", 0x01925841, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M256KG6AE", 0x01925641, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M254KG6AE", 0x01925441, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M258SG6AE", 0x01925811, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M256SG6AE", 0x01925611, IDD_DIALOG_CHIP_SETTING_CFG_M258},
    {"M254SG6AE", 0x01925411, IDD_DIALOG_CHIP_SETTING_CFG_M258},

    /* M2351 series */
    {"M2351KIAAE", 0x00235100, NUC_CHIP_TYPE_M2351},
    {"M2351SIAAE", 0x00235101, NUC_CHIP_TYPE_M2351},
    {"M2351CIAAE", 0x00235102, NUC_CHIP_TYPE_M2351},
    {"M2351ZIAAE", 0x00235103, NUC_CHIP_TYPE_M2351},
    {"M2351SFSIAAP", 0x00235300, NUC_CHIP_TYPE_M2351},

    /* M261 series */
    {"M261ZIAAE", 0x00261000, NUC_CHIP_TYPE_M2351},
    {"M261SIAAE", 0x00261001, NUC_CHIP_TYPE_M2351},
    {"M261KIAAE", 0x00261002, NUC_CHIP_TYPE_M2351},
    {"M262ZIAAE", 0x00262000, NUC_CHIP_TYPE_M2351},
    {"M262SIAAE", 0x00262001, NUC_CHIP_TYPE_M2351},
    {"M262KIAAE", 0x00262002, NUC_CHIP_TYPE_M2351},
    {"M263ZIAAE", 0x00263000, NUC_CHIP_TYPE_M2351},
    {"M263SIAAE", 0x00263001, NUC_CHIP_TYPE_M2351},
    {"M263KIAAE", 0x00263002, NUC_CHIP_TYPE_M2351},

    /* M2354 series */
    {"M2354ES", 0x00235500, NUC_CHIP_TYPE_M2354}, //TC8250
    {"M2354KJFAE", 0xA1735440, NUC_CHIP_TYPE_M2354},
    {"M2354SJFAE", 0xA1735410, NUC_CHIP_TYPE_M2354},
    {"M2354LJFAE", 0xA1735400, NUC_CHIP_TYPE_M2354},
    {"M2354LJFCE", 0xA173540C, NUC_CHIP_TYPE_M2354},

    /* M2L31 */
    {"M2L31KIDAE", 0x01F31040, NUC_CHIP_TYPE_M2L31},
    {"M2L31KGDAE", 0x01F31041, NUC_CHIP_TYPE_M2L31},
    {"M2L31SIDAE", 0x01F31010, NUC_CHIP_TYPE_M2L31},
    {"M2L31SGDAE", 0x01F31011, NUC_CHIP_TYPE_M2L31},
    {"M2L31SG4AE", 0x01F31012, NUC_CHIP_TYPE_M2L31},
    {"M2L31SE4AE", 0x01F31013, NUC_CHIP_TYPE_M2L31},
    {"M2L31LIDAE", 0x01F31000, NUC_CHIP_TYPE_M2L31},
    {"M2L31LGDAE", 0x01F31001, NUC_CHIP_TYPE_M2L31},
    {"M2L31LG4AE", 0x01F31002, NUC_CHIP_TYPE_M2L31},
    {"M2L31LE4AE", 0x01F31003, NUC_CHIP_TYPE_M2L31},
    {"M2L31LD4AE", 0x01F31004, NUC_CHIP_TYPE_M2L31},
    {"M2L31YIDAE", 0x01F31090, NUC_CHIP_TYPE_M2L31},
    {"M2L31YGDAE", 0x01F31091, NUC_CHIP_TYPE_M2L31},
    {"M2L31YG4AE", 0x01F31092, NUC_CHIP_TYPE_M2L31},
    {"M2L31YE4AE", 0x01F31093, NUC_CHIP_TYPE_M2L31},
    {"M2L31YD4AE", 0x01F31094, NUC_CHIP_TYPE_M2L31},
    {"M2L31ZE4AE", 0x01F310C3, NUC_CHIP_TYPE_M2L31},
    {"M2L31ZD4AE", 0x01F310C4, NUC_CHIP_TYPE_M2L31},
    {"M2L31CIDAE", 0x01F310A0, NUC_CHIP_TYPE_M2L31},
    {"M2L31CGDAE", 0x01F310A1, NUC_CHIP_TYPE_M2L31},
    {"M2L31XD4AE", 0x01F310B4, NUC_CHIP_TYPE_M2L31},
    
    /* M2003 */
    {"M2003FC1AE", 0x01F03CB0, NUC_CHIP_TYPE_M2003},
    {"M2003XC1AE", 0x01F03C80, NUC_CHIP_TYPE_M2003},
    {"M2P481QC1AE", 0x01F03C9F, NUC_CHIP_TYPE_M2003},
    {"KN44490A", 0x01F03CFF, NUC_CHIP_TYPE_M2003},

    /* M0A21 */
    {"M0A21OB1AC", 0x015A2121, NUC_CHIP_TYPE_M0A21},
    {"M0A21OC1AC", 0x015A2120, NUC_CHIP_TYPE_M0A21},
    {"M0A21EB1AC", 0x015A21A1, NUC_CHIP_TYPE_M0A21},
    {"M0A21EC1AC", 0x015A21A0, NUC_CHIP_TYPE_M0A21},
    {"M0A23OC1AC", 0x015A2320, NUC_CHIP_TYPE_M0A21},
    {"M0A23EC1AC", 0x015A23A0, NUC_CHIP_TYPE_M0A21},
    {"M0A23OC1ACU", 0x015A2321, NUC_CHIP_TYPE_M0A21},
    {"M0A23EC1ACU", 0x015A23A1, NUC_CHIP_TYPE_M0A21},

    /* M029G */
    {"M029GGC0AE", 0x011296F1, NUC_CHIP_TYPE_M030G},
    /* M030G (GPON) */
    {"M030GGD1AE", 0x011306F0, NUC_CHIP_TYPE_M030G},
    {"M030GTD1AE", 0x011306E0, NUC_CHIP_TYPE_M030G},
    {"M030GGC1AE", 0x011306F2, NUC_CHIP_TYPE_M030G},
    {"M030GTC1AE", 0x011306E2, NUC_CHIP_TYPE_M030G},
    {"M030GGC0AE", 0x011306F1, NUC_CHIP_TYPE_M030G},
    {"M030GTC0AE", 0x011306E1, NUC_CHIP_TYPE_M030G},

    /* M031G (GPON2) */
    {"M031GGD2AE", 0x011316F0, NUC_CHIP_TYPE_M030G},
    {"M031GTD2AE", 0x011316E0, NUC_CHIP_TYPE_M030G},
    {"M031GGC2AE", 0x011316F2, NUC_CHIP_TYPE_M030G},
    {"M031GTC2AE", 0x011316E2, NUC_CHIP_TYPE_M030G},
    {"M031GGC1AE", 0x011316F1, NUC_CHIP_TYPE_M030G},
    {"M031GTC1AE", 0x011316E1, NUC_CHIP_TYPE_M030G},

    /* M091 (M031G + OPA) */
    {"M091TD2AE", 0x011916E0, NUC_CHIP_TYPE_M030G},
    {"M091YD2AE", 0x01191690, NUC_CHIP_TYPE_M030G},
    {"M091TC2AE", 0x011916E2, NUC_CHIP_TYPE_M030G},
    {"M091YC2AE", 0x01191692, NUC_CHIP_TYPE_M030G},

    /* M460 */
    {"M467SJHAE", 0x01B46710, NUC_CHIP_TYPE_M460},
    {"M467KJHAE", 0x01B46740, NUC_CHIP_TYPE_M460},
    {"M467JJHAE", 0x01B46750, NUC_CHIP_TYPE_M460},
    {"M467HJHAE", 0x01B46760, NUC_CHIP_TYPE_M460},
    {"M467H3KJHAE", 0x01B46F40, NUC_CHIP_TYPE_M460},
    {"M467H3JJHAE", 0x01B46F51, NUC_CHIP_TYPE_M460},
    {"M467SJHAN", 0x01B46F11, NUC_CHIP_TYPE_M460},
    {"M467KJHAN", 0x01B46F41, NUC_CHIP_TYPE_M460},
    {"M467JJHAN", 0x01B46F52, NUC_CHIP_TYPE_M460},
    {"M467HJHAN", 0x01B46F61, NUC_CHIP_TYPE_M460},
    {"M467S2JHAE", 0x01B46712, NUC_CHIP_TYPE_M460},
    {"M467K2JHAE", 0x01B46742, NUC_CHIP_TYPE_M460},
    {"M467J2JHAE", 0x01B46752, NUC_CHIP_TYPE_M460},
    {"M467H2JHAE", 0x01B46762, NUC_CHIP_TYPE_M460},
    {"M463KGCAE", 0x01C46340, NUC_CHIP_TYPE_M460},
    {"M463VGCAE", 0x01C46330, NUC_CHIP_TYPE_M460},
    {"M463SGCAE", 0x01C46310, NUC_CHIP_TYPE_M460},
    {"M463LGCAE", 0x01C46300, NUC_CHIP_TYPE_M460},
    {"M463YGCAE", 0x01C46390, NUC_CHIP_TYPE_M460},
    {"M460KGCAE", 0x01C46040, NUC_CHIP_TYPE_M460},
    {"M460SGCAE", 0x01C46010, NUC_CHIP_TYPE_M460},
    {"M460LGCAE", 0x01C46000, NUC_CHIP_TYPE_M460},
    {"M460YGCAE", 0x01C46090, NUC_CHIP_TYPE_M460},   
    {"M463K2GCAC", 0x01C4634E, NUC_CHIP_TYPE_M460},  
    {"M463S2GCAC", 0x01C4631E, NUC_CHIP_TYPE_M460},
    {"M463L2GCAC", 0x01C4630E, NUC_CHIP_TYPE_M460},

    /* M471 */
    {"M471KI8AE", 0x01647140, NUC_CHIP_TYPE_M471},
    {"M471VI8AE", 0x01647130, NUC_CHIP_TYPE_M471},
    {"M471VG7AE", 0x01647131, NUC_CHIP_TYPE_M471},
    {"M471CI8AE", 0x016471F0, NUC_CHIP_TYPE_M471},

    {"M471R1E6AE", 0x01647192, NUC_CHIP_TYPE_M451},
    {"M471R1D6AE", 0x01647193, NUC_CHIP_TYPE_M451},
    {"M471SE6AE", 0x01647112, NUC_CHIP_TYPE_M451},
    {"M471SD6AE", 0x01647113, NUC_CHIP_TYPE_M451},
    {"M471MD6AE", 0x016471A3, NUC_CHIP_TYPE_M451},

    /* M071 */
    {"M071MC2AE", 0x016071A5, IDD_DIALOG_CONFIGURATION_NUC131},
    {"M071MD2AE", 0x016071A4, IDD_DIALOG_CONFIGURATION_NUC131},
    {"M071R1D3AE", 0x01607193, IDD_DIALOG_CONFIGURATION_NUC200},
    {"M071R1E3AE", 0x01607192, IDD_DIALOG_CONFIGURATION_NUC200},
    {"M071SD3AE", 0x01607113, IDD_DIALOG_CONFIGURATION_NUC200},
    {"M071SE3AE", 0x01607112, IDD_DIALOG_CONFIGURATION_NUC200},
    {"M071VG4AE", 0x01607130, IDD_DIALOG_CONFIGURATION_M0564},

    /* 8051 1T N76 & ML51 & MS51 series */
    {"N76E885",   0x00002150, NUC_CHIP_TYPE_GENERAL_1T},

    {"N76E616",   0x00002F50, NUC_CHIP_TYPE_GENERAL_1T},

    {"N76E003",   0x00003650, NUC_CHIP_TYPE_GENERAL_1T},

    // For ML51, Version A (PID0 = 0x00), Version B (PID0 = 0x10)
    {"ML51TC0AE", 0x0C104832, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51PC0AE", 0x01104832, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51EC0AE", 0x02104832, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51UC0AE", 0x03104832, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51TB9AE", 0x0C104821, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51PB9AE", 0x01104821, NUC_CHIP_TYPE_GENERAL_1T},

    {"ML51UB9AE", 0x03104721, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51EB9AE", 0x02104721, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51XB9AE", 0x0D104721, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51OB9AE", 0x04104721, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51FB9AE", 0x0B104721, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51DB9AE", 0x09104721, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51BB9AE", 0x06104721, NUC_CHIP_TYPE_GENERAL_1T},

    {"MS51FB9AE", 0x0B004B21, NUC_CHIP_TYPE_GENERAL_1T},
    {"MS51XB9AE", 0x05004B21, NUC_CHIP_TYPE_GENERAL_1T},
    {"MS51XB9BE", 0x0E004B21, NUC_CHIP_TYPE_GENERAL_1T},

    {"NM18002Y", 0x1D004B21, NUC_CHIP_TYPE_GENERAL_1T},

    {"MS51DA9AE", 0x0A005211, NUC_CHIP_TYPE_GENERAL_1T},
    {"MS51BA9AE", 0x06005211, NUC_CHIP_TYPE_GENERAL_1T},

    {"MS51FC0AE", 0x0B005332, NUC_CHIP_TYPE_GENERAL_1T},
    {"MS51XC0BE", 0x0E005332, NUC_CHIP_TYPE_GENERAL_1T},
    {"MS51EC0AE", 0x02005332, NUC_CHIP_TYPE_GENERAL_1T},
    {"MS51TC0AE", 0x0C005332, NUC_CHIP_TYPE_GENERAL_1T},
    {"MS51PC0AE", 0x01005332, NUC_CHIP_TYPE_GENERAL_1T},

    {"MS51EB0AE", 0x02005322, NUC_CHIP_TYPE_GENERAL_1T},

    {"ML56SD1AE", 0x08125744, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML56LD1AE", 0x00125744, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML56MD1AE", 0x07125744, NUC_CHIP_TYPE_GENERAL_1T},

    {"ML54SD1AE", 0x08115744, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML54LD1AE", 0x00115744, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML54MD1AE", 0x07115744, NUC_CHIP_TYPE_GENERAL_1T},

    {"ML51SD1AE", 0x08105744, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51LD1AE", 0x00105744, NUC_CHIP_TYPE_GENERAL_1T},
    {"ML51TD1AE", 0x0C105744, NUC_CHIP_TYPE_GENERAL_1T},

    {"MUG51TB9AE", 0x0C106321, NUC_CHIP_TYPE_GENERAL_1T},
    {"MUG51W",     0xFFFF6321, NUC_CHIP_TYPE_GENERAL_1T},

    /* KAG056 */
    {"MG51XB9AE", 0x05006721, NUC_CHIP_TYPE_GENERAL_1T},
    {"MG51FB9AE", 0x0B006721, NUC_CHIP_TYPE_GENERAL_1T},
    {"MG51XC9AE", 0x05006731, NUC_CHIP_TYPE_GENERAL_1T},
    {"MG51FC9AE", 0x0B006731, NUC_CHIP_TYPE_GENERAL_1T},
    {"N76S003AQ20", 0x05006750, NUC_CHIP_TYPE_GENERAL_1T},
    {"N76S003AT20", 0x0B006750, NUC_CHIP_TYPE_GENERAL_1T},
    {"---------", 0xFFFFFFFF, 0},
};

